[inherit('common')]
module predis;

type
   cache_ctx = integer64;
   it_ctx = integer64;

[external('VMS_HIREDIS_CONNECT')]
function predis_connect(%STDESCR host : packed array [l1..u1:integer] of char;
                        %REF port : integer;
                        %REF cache_id : integer;
                        %REF cache_handle : cache_ctx) : integer; extern;

[external('VMS_HIREDIS_SET_STRING')]
function predis_set_string(%REF cache_handle : cache_ctx;
                           %STDESCR key : packed array [l1..u1:integer] of char;
                           %STDESCR val : packed array [l2..u2:integer] of char) : integer; extern;

[external('VMS_HIREDIS_SET_INTEGER')]
function predis_set_integer(%REF cache_handle : cache_ctx;
                            %STDESCR key : packed array [l1..u1:integer] of char;
                            %REF val : integer) : integer; extern;

[external('VMS_HIREDIS_GET_STRING')]
function predis_get_string(%REF cache_handle : cache_ctx;
                           %STDESCR key : packed array [l1..u1:integer] of char;
                           %STDESCR val : packed array [l2..u2:integer] of char;
                           %REF vallen : word) : integer; extern;

[external('VMS_HIREDIS_GET_INTEGER')]
function predis_get_integer(%REF cache_handle : cache_ctx;
                            %STDESCR key : packed array [l1..u1:integer] of char;
                            %REF val : integer) : integer; extern;

[external('VMS_HIREDIS_KEYS_LOOKUP')]
function predis_keys_lookup(%REF cache_handle : cache_ctx;
                            %STDESCR key : packed array [l1..u1:integer] of char;
                            %REF it_handle : it_ctx) : integer; extern;


[external('VMS_HIREDIS_KEYS_COUNT')]
function predis_keys_count(%REF it_handle : it_ctx) : integer; extern;

[external('VMS_HIREDIS_KEYS_GET')]
procedure predis_keys_get(%REF it_handle : it_ctx;
                          %REF ix : integer;
                          %STDESCR key : packed array [l2..u2:integer] of char;
                          %REF keylen : word); extern;

[external('VMS_HIREDIS_KEYS_FREE')]
procedure predis_keys_free(%REF it_handle : it_ctx); extern;

[external('VMS_HIREDIS_DISCONNECT')]
procedure predis_disconnect(%REF cache_handle : cache_ctx); extern;

end.
