[inherit('common', 'predis')]
program test(input,output);

var
   cache : cache_ctx;
   it : it_ctx;
   stat : integer;
   v1 : varying [255] of char;
   v2 : integer;
   key : pstr;
   i, ix : integer;

begin
   stat := predis_connect('localhost', 6379, 8, cache);
   if not odd(stat) then writeln('Error predis_connect');
   stat := predis_set_string(cache, 'v1', 'ABC');
   if not odd(stat) then writeln('Error predis_set_string');
   stat := predis_set_integer(cache, 'v2', 123);
   if not odd(stat) then writeln('Error predis_set_integer');
   stat := predis_get_string(cache, 'v1', v1.body, v1.length);
   if not odd(stat) then writeln('Error predis_get_string');
   writeln('|' + v1 + '|');
   stat := predis_get_integer(cache, 'v2', v2);
   if not odd(stat) then writeln('Error predis_get_integer');
   writeln(v2:0);
   stat := predis_keys_lookup(cache, '*', it);
   for i := 1 to predis_keys_count(it) do begin
      ix := i;
      predis_keys_get(it, ix, key.body, key.length);
      writeln('|' + key + '|');
   end;
   predis_keys_free(it);
   predis_disconnect(cache);
end.
